function Kngu = curvature(u, i, j, k, D)
% This routine computes the curvature times a norm of the gradient of u
[xn yn zn] = size(u);
[nD2 nD Dx Dy Dz Dxx Dyy Dzz Dxy Dyz Dzx] = D{:};
dx = Dx(u,i,j,k); dx2 = dx*dx;
dy = Dy(u,i,j,k); dy2 = dy*dy;
dz = Dz(u,i,j,k); dz2 = dz*dz;
dxx = Dxx(u,i,j,k);
dyy = Dyy(u,i,j,k);
dzz = Dzz(u,i,j,k);
dxy = Dxy(u,i,j,k);
dyz = Dyz(u,i,j,k);
dzx = Dzx(u,i,j,k);
Kngu = (dx2*dyy - 2*dx*dy*dxy + dy2*dxx + ...
        dx2*dzz - 2*dx*dz*dzx + dz2*dxx + ...
        dy2*dzz - 2*dy*dz*dyz + dz2*dyy)/(nD2(u,i,j,k));
if isnan(Kngu)
  Kngu = 0;
end
