function dispoutput(u0, h, filename, color)
if nargin < 4
  color = 'blue';
end
% Draw the zero level set of u0

u = u0(2:end-1, 2:end-1, 2:end-1); % shave off boundaries

% Construct domain matrices
x = h:h:1-h; 
y = x; z = x;
[X, Y, Z] = meshgrid(x,y,z);
ah = axes();
axis(ah, [0 1 0 1 0 1]);     % set axis limits
set(ah, 'PlotBoxAspectRatioMode', 'manual', 'PlotBoxAspectRatio', [1 1 1]);
hold on

% Draw isosurface
p = patch(isosurface(X, Y, Z, u, 0));
isonormals(X,Y,Z,u,p); % Generate normals for viewing
set(p, 'FaceColor', color, 'EdgeColor', 'none');
view(3);         % standard viewing angle
camlight         % light source from the camera
lighting phong   % set shading method

if nargin > 2
  savesqpdf(filename); % optionally  save plot to a file
end

