function E = energynarrow(u, d, nD, h, mask, idx)
% compute the energy of the interface
eps = 1.5*h; % smearing constant
dom = 0:h:1; % domain in each dimension
epsinv = 1/eps;
integrand = zeros(size(u));
for l = idx
  i = l(1); j = l(2); k = l(3);
  if mask(i,j,k) == 2
    delta = 0;
    if u(i,j,k) > -eps && u(i,j,k) < eps
      delta = 0.5*epsinv*(1 + cos(pi*u(i,j,k)*epsinv));
      d2 = d(i,j,k)*d(i,j,k);
      integrand(i,j,k) = delta*d2*nD(u,i,j,k);
    end
  end % if mask == 2
end % for each idx

% compute tripple integral for the energy
E = trapz(dom, trapz(dom, trapz(dom, integrand, 1), 2), 3);
