function v = gencircle(n, c, R)
% Generate a uniformly distributed set of n points on a circle with radius R
% represented by an array of (x,y) coordinates
% n - number of points in output
% c - coordinates of the centre of the circle
% R - radius of the circle
% v - coordinates (first row -> x coordinate)

dt = 2*pi/n;     % single division in angle
t = dt*[1:n];
v = c*ones(1,n) + R*[cos(t); sin(t)];

