function [mask idx n] = gennarrowband(u, gamma)
% generate the mask and idx set to simulate a narrow band
mask = zeros(size(u));
[xn yn zn] = size(u);
idx = zeros(3, xn*yn*zn);  % index into mask
% initialize narrow band mask
n = 0;
for i = 2:xn-1
  for j = 2:yn-1
    for k = 2:zn-1
      if abs(u(i,j,k)) < gamma
        n = n + 1;
        mask(i,j,k) = 2;
        idx(:, n) = [i;j;k];
      else
        for s = [-1 1]
          if abs(u(i+s,j,k)) < gamma || ...
             abs(u(i,j+s,k)) < gamma || ...
             abs(u(i,j,k+s)) < gamma
            n = n + 1;
            mask(i,j,k) = 1;
            idx(:, n) = [i;j;k];
            break;
          end
        end
      end
    end % for each k
  end % for each j
end % for each i

idx(:, n+1:end) = [];
