function [gu ngu] = grad(u)
% compute gradient of the given function u and its norm

[xn yn zn] = size(u);

initderivatives % initialize the derivative functions

gu = zeros(3, xn, yn, zn);
ngu = zeros(xn, yn, zn);
for i = 2:xn-1
  for j = 2:yn-1
    for k = 2:zn-1
      dx = Dx(u,i,j,k);
      dy = Dy(u,i,j,k);
      dz = Dz(u,i,j,k);
      dxyz = [dx; dy; dz];
      gu(:,i,j,k) = dxyz;
      ngu(i,j,k) = norm(dxyz);
    end % for each k
  end % for each j
end % for each i
