function u = reinitialize(u, nD, h, mask, idx);
N = min(size(u));
for l = idx
  i = l(1); j = l(2); k = l(3);
  if mask(i,j,k) > 0
    u2 = u(i,j,k)*u(i,j,k);
    s(i,j,k) = u(i,j,k)/sqrt(u2 + nD(u,i,j,k)*h*h);
  end % if mask == 1 or 2 
end
guf = gradnarrowfull(u, mask, idx);
dtaudh = 1/256; % pick a time step for reinitialization
for l = idx
  i = l(1); j = l(2); k = l(3);
  dxm = guf(1,i,j,k); dym = guf(2,i,j,k); dzm = guf(3,i,j,k);
  dxp = guf(4,i,j,k); dyp = guf(5,i,j,k); dzp = guf(6,i,j,k);
  if mask(i,j,k) > 0
    if s(i,j,k) > 0
      dx = max(max(0, dxm), -min(0, dxp));
      dy = max(max(0, dym), -min(0, dyp));
      dz = max(max(0, dzm), -min(0, dzp));
    else
      dx = max(max(0, dxp), -min(0, dxm));
      dy = max(max(0, dyp), -min(0, dym));
      dz = max(max(0, dzp), -min(0, dzm));
    end
    sq = norm([dx dy dz]);
    u(i,j,k) = u(i,j,k) + dtaudh*s(i,j,k)*(1 - sq);
  end % if mask == 1 or 2
end
