function d = slowdist(S, N)
% function d = slowdist(S, N)
% Compute the exact distance function from the given data set S
% on an NxNxN grid of [0,1]^3

[xn yn zn] = deal(N); % num grid points in x y and z

nc = N-1; % number of cells in each dimension
h = 1.0/double(nc);

d = inf*ones(xn, yn, zn);
for i = 1:N
  for j = 1:N
    for k = 1:N
      for pt = S
        dist = norm(pt - [(i-1)*h; (j-1)*h; (k-1)*h]);
        if d(i,j,k) > dist
          d(i,j,k) = dist;
        end
      end
    end
  end
end
